<?php

namespace Drupal\entity_share_websub_hub\EventSubscriber;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\EventDispatcher\Event;
use Drupal\entity_share_websub_hub\HubInterface;
use Symfony\Component\HttpKernel\KernelEvents;

/**
 * Class NotificationProcessor.
 */
class NotificationProcessor implements EventSubscriberInterface {

  /**
   * Drupal\entity_share_websub_hub\HubInterface definition.
   *
   * @var \Drupal\entity_share_websub_hub\HubInterface
   */
  protected $hub;

  /**
   * Constructs a new NotificationProcessor object.
   */
  public function __construct(HubInterface $entity_share_websub_hub_hub) {
    $this->hub = $entity_share_websub_hub_hub;
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    $events[KernelEvents::TERMINATE] = ['kernelTerminate'];

    return $events;
  }

  /**
   * This method is called when the kernel.terminate is dispatched.
   *
   * @param \Symfony\Component\EventDispatcher\Event $event
   *   The dispatched event.
   */
  public function kernelTerminate(Event $event) {
    $this->hub->processUpdates();
  }

}
