<?php

namespace Drupal\entity_share_websub;

use Drupal\Component\Utility\UrlHelper;

/**
 * Trait SignatureTrait.
 */
trait SignatureTrait {

  /**
   * Get the hub signature for webhub protocol.
   *
   * @param array|object $data
   *   A serializeable data structure.
   * @param string $secret
   *   A secret string.
   *
   * @return string
   *   The signature.
   */
  protected function getSignature($data, $secret) {
    if (is_array($data)) {
      parse_str(UrlHelper::buildQuery($data), $data);
    }
    $signature = hash('sha256', $secret . serialize($data));
    return "sha256=$signature";
  }

}
